import unittest

class TestImporting(unittest.TestCase):
    def test_imports(self):
        # Importing
        #
        # Normally imports are done at the global level (under the
        # import unittest above). For this assignment you will be
        # adding import statements up there until the tests pass.
        #
        # (Note you can also define imports inside a method, but it
        # isn't really too common a practice).


        # Import the ``sys`` library
        # ================================

        self.assertTrue('sys' in locals())
        self.assertTrue(len(sys.path))

        # from
        #
        # import the ``cos`` function from the ``math`` module
        # ================================

        self.assertTrue('cos' in locals())
        self.assertEquals(int(cos(0)), 1)

        # as
        #
        # Use ``as`` to rename the ``sin`` function from ``math``
        # to ``sine``
        # ================================

        self.assertTrue('sin' not in locals())
        self.assertTrue('sine' in locals())
        self.assertEquals(int(sine(0)), 0)

        # sys.path tweaking
        #
        # Create a file ``/tmp/foo.py``, with this line (you can do it manually):
        #
        # name = 'fred'
        #
        # Update sys.path and add "/tmp/" to it. Import the foo.py
        # module.
        # ================================

        self.assertTrue('foo' in locals())
        self.assertEquals(foo.name, 'fred')

if __name__ == '__main__':
    unittest.main()





